<?php

$discs = 4;
$bins  = 3;

$max_combinations = pow($bins, $discs);

for($combination = 0; $combination < $max_combinations; ++$combination)
{
  $locations = Array();
  $pos = $combination;
  for($disc = 0; $disc < $discs; ++$disc)
  {
    $locations[$disc] = $pos % $bins;
    $pos = (int)($pos / $bins);
  }

  print "[state$combination]\n";
  
  $top = Array();
  for($bin=0; $bin<$bins; ++$bin)
  {
    $top[$bin] = -1;
    $binname = chr(65+$bin);
    print "Bin $binname: ";
    for($disc = $discs; $disc-- > 0; )
      if($locations[$disc] == $bin)
      {
        $top[$bin] = $disc;
        print "$disc ";
      }
    print "\n";
  }
  
  if($top[0] == -1 && $top[1] == -1)
  {
    print "GAME COMPLETE (ENDING 1 OF 2)\n";
    print "\$ ENDING_ONE 1\n";
    print "> CHECK_ENDING\n";
    continue;
  }
  
  if($top[0] == -1 && $top[2] == -1)
  {
    print "GAME COMPLETE (ENDING 2 OF 2)\n";
    print "\$ ENDING_TWO 1\n";
    print "> CHECK_ENDING\n";
    continue;
  }
  
  for($frombin = 0; $frombin < $bins; ++$frombin)
    if($top[$frombin] >= 0) // bin is not empty
      for($tobin = 0; $tobin < $bins; ++$tobin)
        if($frombin != $tobin) // redundant move
          if($top[$frombin] < $top[$tobin] || $top[$tobin] == -1)
          {
            // Suggest this move
            $tgt_pos = 0;
            for($disc = $discs; $disc-- > 0; )
            {
              $tgt_pos *= $bins;
              if($disc == $top[$frombin])
                $tgt_pos += $tobin;
              else
                $tgt_pos += $locations[$disc];
            }
            $frombinname = chr(65+$frombin);
            $tobinname = chr(65+$tobin);
            print ": state$tgt_pos Move disc {$top[$frombin]} from bin $frombinname to bin $tobinname\n";
          }
  print "\n";
}
