<?php
define('MAGIC', 'StoryBook');
/* ATTRIBUTES */
$attrlist = Array(
  'CUR_ROOM' => Array(0, 82),
  'ENDING_ONE' => Array(0, 1),
  'ENDING_TWO' => Array(0, 1)
);
/* INITIAL ATTRIBUTES */
foreach($attrlist as $k => $v)
  $GLOBALS[$k] = $v[0];

define('MAX_INTEGER', 0x1FFFFFFF);
/* Request handling */
function EncodeRequest()
{
  global $attrlist;
  $result = '';
  $value  = 0;
  $factor = 1;
  $remain = count($attrlist);
  foreach($attrlist as $attrname => $attrspecs)
  {
    $max      = $attrspecs[1];
    $flush = (--$remain == 0 || ($max*$factor >= MAX_INTEGER));
    if($flush)
    {
      $ndigits = ceil(log($factor) / log(36));
      for($base = 36; $base > 2; --$base)
      {
        $ndigits2 = ceil(log($factor) / log($base-1));
        if($ndigits2 != $ndigits) break;
        $ndigits = $ndigits2;
      }
      $item = base_convert($value, 10, $base);
      while(strlen($item) < $ndigits) $item = "0$item";
      $result .= $item;
      $factor  = 1;
      $value   = 0;
    }
    $value += ($GLOBALS[$attrname] ^ $attrspecs[0]) * $factor;
    $factor *= ($max+1);
  }
  $cksum = sprintf('%s', substr(base_convert(sha1(MAGIC.$result),16,36),0,1));
  $result .= $cksum;
  return $result;
}
function DecodeRequest()
{
  if(!isset($_GET['req'])) return true;
  global $attrlist, $max;
  $req = $_GET['req'];
  $pos = 0;

  $value  = 0;
  $factor = 1;
  $remain = count($attrlist);
  $do_list = Array();
  foreach($attrlist as $attrname => $attrspecs)
  {
    $max      = $attrspecs[1];
    $flush = (--$remain == 0 || ($max*$factor >= MAX_INTEGER));
    if($flush)
    {
      $ndigits = ceil(log($factor) / log(36));
      for($base = 36; $base > 2; --$base)
      {
        $ndigits2 = ceil(log($factor) / log($base-1));
        if($ndigits2 != $ndigits) break;
        $ndigits = $ndigits2;
      }
      if($pos + $ndigits > strlen($req)) return false;
      $item = substr($req, $pos, $ndigits);
      $pos += $ndigits;
      $value  = base_convert($item, $base, 10);
      foreach($do_list as $do_attrname)
      {
        $do_attrspecs = $attrlist[$do_attrname];
        $do_max       = $do_attrspecs[1];
        $val = ($value % ($do_max+1));
        $val ^= $do_attrspecs[0];
        #print "sets $do_attrname to $val<br>";
        $GLOBALS[$do_attrname] = $val;
        $value = (int)($value / ($do_max+1));
      }
      if($value != 0) return false;
      $do_list = Array();
      $factor  = 1;
    }
    $do_list[] = $attrname;
    $factor *= ($max+1);
  }

  $result = substr($req,0,$pos);
  $cksum = sprintf('%s', substr(base_convert(sha1(MAGIC.$result),16,36),0,1));
  if(substr($req, $pos) != $cksum)
  {
    return false;
  }
  return true;
}
if(!DecodeRequest()) die('Request error');
$DESC    = '';
$OPTIONS = Array();

function AppendDesc(&$my_desc)
{
  $lines = explode("\n", $my_desc);
  sort($lines);
  global $DESC;
  $DESC .= join("\n", $lines)."\n";
  $my_desc = '';
}
function Collect($state)
{
  global $OPTIONS;
  $next = $state;
  do {
  $assigns = Array();
  $my_desc = '';
  $state   = $next;
  $next    = -1;
  switch($state)
  {
    case 0: // BEGIN:
      $my_desc .= "00000:TOWERS OF HANOI!\n00001:Move all discs from bin A into bin C (or bin C).\n";
      $next = 2; /* state0 */
      break;
    case 1: // CHECK_ENDING:
      $my_desc .= "";
      if(($GLOBALS['ENDING_ONE'] == 1)) {
      }
      if(($GLOBALS['ENDING_ONE'] == 1) && ($GLOBALS['ENDING_TWO'] == 1)) {
        $my_desc .= "00002:You have discovered both endings! Congratulations.\n";
      }
      if(($GLOBALS['ENDING_ONE'] == 0)) {
        $my_desc .= "00003:You have discovered one ending, one more to go.\n";
        $next = 0; /* BEGIN */
      }
      if(($GLOBALS['ENDING_TWO'] == 0)) {
        $my_desc .= "00004:You have discovered one ending, one more to go.\n";
        $next = 0; /* BEGIN */
      }
      break;
    case 2: // state0:
      $my_desc .= "00005:Bin A: 3 2 1 0\n00006:Bin B:\n00007:Bin C:\n";
      $OPTIONS["00008:Move disc 0 from bin A to bin B\n"] = 3;
      $OPTIONS["00009:Move disc 0 from bin A to bin C\n"] = 4;
      break;
    case 3: // state1:
      $my_desc .= "00010:Bin A: 3 2 1\n00011:Bin B: 0\n00012:Bin C:\n";
      $OPTIONS["00013:Move disc 1 from bin A to bin C\n"] = 9;
      $OPTIONS["00014:Move disc 0 from bin B to bin A\n"] = 2;
      $OPTIONS["00015:Move disc 0 from bin B to bin C\n"] = 4;
      break;
    case 4: // state2:
      $my_desc .= "00016:Bin A: 3 2 1\n00017:Bin B:\n00018:Bin C: 0\n";
      $OPTIONS["00019:Move disc 1 from bin A to bin B\n"] = 7;
      $OPTIONS["00020:Move disc 0 from bin C to bin A\n"] = 2;
      $OPTIONS["00021:Move disc 0 from bin C to bin B\n"] = 3;
      break;
    case 5: // state3:
      $my_desc .= "00022:Bin A: 3 2 0\n00023:Bin B: 1\n00024:Bin C:\n";
      $OPTIONS["00025:Move disc 0 from bin A to bin B\n"] = 6;
      $OPTIONS["00026:Move disc 0 from bin A to bin C\n"] = 7;
      $OPTIONS["00027:Move disc 1 from bin B to bin C\n"] = 8;
      break;
    case 6: // state4:
      $my_desc .= "00028:Bin A: 3 2\n00029:Bin B: 1 0\n00030:Bin C:\n";
      $OPTIONS["00031:Move disc 2 from bin A to bin C\n"] = 24;
      $OPTIONS["00032:Move disc 0 from bin B to bin A\n"] = 5;
      $OPTIONS["00033:Move disc 0 from bin B to bin C\n"] = 7;
      break;
    case 7: // state5:
      $my_desc .= "00034:Bin A: 3 2\n00035:Bin B: 1\n00036:Bin C: 0\n";
      $OPTIONS["00037:Move disc 1 from bin B to bin A\n"] = 4;
      $OPTIONS["00038:Move disc 0 from bin C to bin A\n"] = 5;
      $OPTIONS["00039:Move disc 0 from bin C to bin B\n"] = 6;
      break;
    case 8: // state6:
      $my_desc .= "00040:Bin A: 3 2 0\n00041:Bin B:\n00042:Bin C: 1\n";
      $OPTIONS["00043:Move disc 0 from bin A to bin B\n"] = 9;
      $OPTIONS["00044:Move disc 0 from bin A to bin C\n"] = 10;
      $OPTIONS["00045:Move disc 1 from bin C to bin B\n"] = 5;
      break;
    case 9: // state7:
      $my_desc .= "00046:Bin A: 3 2\n00047:Bin B: 0\n00048:Bin C: 1\n";
      $OPTIONS["00049:Move disc 0 from bin B to bin A\n"] = 8;
      $OPTIONS["00050:Move disc 0 from bin B to bin C\n"] = 10;
      $OPTIONS["00051:Move disc 1 from bin C to bin A\n"] = 3;
      break;
    case 10: // state8:
      $my_desc .= "00052:Bin A: 3 2\n00053:Bin B:\n00054:Bin C: 1 0\n";
      $OPTIONS["00055:Move disc 2 from bin A to bin B\n"] = 19;
      $OPTIONS["00056:Move disc 0 from bin C to bin A\n"] = 8;
      $OPTIONS["00057:Move disc 0 from bin C to bin B\n"] = 9;
      break;
    case 11: // state9:
      $my_desc .= "00058:Bin A: 3 1 0\n00059:Bin B: 2\n00060:Bin C:\n";
      $OPTIONS["00061:Move disc 0 from bin A to bin B\n"] = 12;
      $OPTIONS["00062:Move disc 0 from bin A to bin C\n"] = 13;
      $OPTIONS["00063:Move disc 2 from bin B to bin C\n"] = 20;
      break;
    case 12: // state10:
      $my_desc .= "00064:Bin A: 3 1\n00065:Bin B: 2 0\n00066:Bin C:\n";
      $OPTIONS["00067:Move disc 1 from bin A to bin C\n"] = 18;
      $OPTIONS["00068:Move disc 0 from bin B to bin A\n"] = 11;
      $OPTIONS["00069:Move disc 0 from bin B to bin C\n"] = 13;
      break;
    case 13: // state11:
      $my_desc .= "00070:Bin A: 3 1\n00071:Bin B: 2\n00072:Bin C: 0\n";
      $OPTIONS["00073:Move disc 1 from bin A to bin B\n"] = 16;
      $OPTIONS["00074:Move disc 0 from bin C to bin A\n"] = 11;
      $OPTIONS["00075:Move disc 0 from bin C to bin B\n"] = 12;
      break;
    case 14: // state12:
      $my_desc .= "00076:Bin A: 3 0\n00077:Bin B: 2 1\n00078:Bin C:\n";
      $OPTIONS["00079:Move disc 0 from bin A to bin B\n"] = 15;
      $OPTIONS["00080:Move disc 0 from bin A to bin C\n"] = 16;
      $OPTIONS["00081:Move disc 1 from bin B to bin C\n"] = 17;
      break;
    case 15: // state13:
      $my_desc .= "00082:Bin A: 3\n00083:Bin B: 2 1 0\n00084:Bin C:\n";
      $OPTIONS["00085:Move disc 3 from bin A to bin C\n"] = 69;
      $OPTIONS["00086:Move disc 0 from bin B to bin A\n"] = 14;
      $OPTIONS["00087:Move disc 0 from bin B to bin C\n"] = 16;
      break;
    case 16: // state14:
      $my_desc .= "00088:Bin A: 3\n00089:Bin B: 2 1\n00090:Bin C: 0\n";
      $OPTIONS["00091:Move disc 1 from bin B to bin A\n"] = 13;
      $OPTIONS["00092:Move disc 0 from bin C to bin A\n"] = 14;
      $OPTIONS["00093:Move disc 0 from bin C to bin B\n"] = 15;
      break;
    case 17: // state15:
      $my_desc .= "00094:Bin A: 3 0\n00095:Bin B: 2\n00096:Bin C: 1\n";
      $OPTIONS["00097:Move disc 0 from bin A to bin B\n"] = 18;
      $OPTIONS["00098:Move disc 0 from bin A to bin C\n"] = 19;
      $OPTIONS["00099:Move disc 1 from bin C to bin B\n"] = 14;
      break;
    case 18: // state16:
      $my_desc .= "00100:Bin A: 3\n00101:Bin B: 2 0\n00102:Bin C: 1\n";
      $OPTIONS["00103:Move disc 0 from bin B to bin A\n"] = 17;
      $OPTIONS["00104:Move disc 0 from bin B to bin C\n"] = 19;
      $OPTIONS["00105:Move disc 1 from bin C to bin A\n"] = 12;
      break;
    case 19: // state17:
      $my_desc .= "00106:Bin A: 3\n00107:Bin B: 2\n00108:Bin C: 1 0\n";
      $OPTIONS["00109:Move disc 2 from bin B to bin A\n"] = 10;
      $OPTIONS["00110:Move disc 0 from bin C to bin A\n"] = 17;
      $OPTIONS["00111:Move disc 0 from bin C to bin B\n"] = 18;
      break;
    case 20: // state18:
      $my_desc .= "00112:Bin A: 3 1 0\n00113:Bin B:\n00114:Bin C: 2\n";
      $OPTIONS["00115:Move disc 0 from bin A to bin B\n"] = 21;
      $OPTIONS["00116:Move disc 0 from bin A to bin C\n"] = 22;
      $OPTIONS["00117:Move disc 2 from bin C to bin B\n"] = 11;
      break;
    case 21: // state19:
      $my_desc .= "00118:Bin A: 3 1\n00119:Bin B: 0\n00120:Bin C: 2\n";
      $OPTIONS["00121:Move disc 1 from bin A to bin C\n"] = 27;
      $OPTIONS["00122:Move disc 0 from bin B to bin A\n"] = 20;
      $OPTIONS["00123:Move disc 0 from bin B to bin C\n"] = 22;
      break;
    case 22: // state20:
      $my_desc .= "00124:Bin A: 3 1\n00125:Bin B:\n00126:Bin C: 2 0\n";
      $OPTIONS["00127:Move disc 1 from bin A to bin B\n"] = 25;
      $OPTIONS["00128:Move disc 0 from bin C to bin A\n"] = 20;
      $OPTIONS["00129:Move disc 0 from bin C to bin B\n"] = 21;
      break;
    case 23: // state21:
      $my_desc .= "00130:Bin A: 3 0\n00131:Bin B: 1\n00132:Bin C: 2\n";
      $OPTIONS["00133:Move disc 0 from bin A to bin B\n"] = 24;
      $OPTIONS["00134:Move disc 0 from bin A to bin C\n"] = 25;
      $OPTIONS["00135:Move disc 1 from bin B to bin C\n"] = 26;
      break;
    case 24: // state22:
      $my_desc .= "00136:Bin A: 3\n00137:Bin B: 1 0\n00138:Bin C: 2\n";
      $OPTIONS["00139:Move disc 0 from bin B to bin A\n"] = 23;
      $OPTIONS["00140:Move disc 0 from bin B to bin C\n"] = 25;
      $OPTIONS["00141:Move disc 2 from bin C to bin A\n"] = 6;
      break;
    case 25: // state23:
      $my_desc .= "00142:Bin A: 3\n00143:Bin B: 1\n00144:Bin C: 2 0\n";
      $OPTIONS["00145:Move disc 1 from bin B to bin A\n"] = 22;
      $OPTIONS["00146:Move disc 0 from bin C to bin A\n"] = 23;
      $OPTIONS["00147:Move disc 0 from bin C to bin B\n"] = 24;
      break;
    case 26: // state24:
      $my_desc .= "00148:Bin A: 3 0\n00149:Bin B:\n00150:Bin C: 2 1\n";
      $OPTIONS["00151:Move disc 0 from bin A to bin B\n"] = 27;
      $OPTIONS["00152:Move disc 0 from bin A to bin C\n"] = 28;
      $OPTIONS["00153:Move disc 1 from bin C to bin B\n"] = 23;
      break;
    case 27: // state25:
      $my_desc .= "00154:Bin A: 3\n00155:Bin B: 0\n00156:Bin C: 2 1\n";
      $OPTIONS["00157:Move disc 0 from bin B to bin A\n"] = 26;
      $OPTIONS["00158:Move disc 0 from bin B to bin C\n"] = 28;
      $OPTIONS["00159:Move disc 1 from bin C to bin A\n"] = 21;
      break;
    case 28: // state26:
      $my_desc .= "00160:Bin A: 3\n00161:Bin B:\n00162:Bin C: 2 1 0\n";
      $OPTIONS["00163:Move disc 3 from bin A to bin B\n"] = 55;
      $OPTIONS["00164:Move disc 0 from bin C to bin A\n"] = 26;
      $OPTIONS["00165:Move disc 0 from bin C to bin B\n"] = 27;
      break;
    case 29: // state27:
      $my_desc .= "00166:Bin A: 2 1 0\n00167:Bin B: 3\n00168:Bin C:\n";
      $OPTIONS["00169:Move disc 0 from bin A to bin B\n"] = 30;
      $OPTIONS["00170:Move disc 0 from bin A to bin C\n"] = 31;
      $OPTIONS["00171:Move disc 3 from bin B to bin C\n"] = 56;
      break;
    case 30: // state28:
      $my_desc .= "00172:Bin A: 2 1\n00173:Bin B: 3 0\n00174:Bin C:\n";
      $OPTIONS["00175:Move disc 1 from bin A to bin C\n"] = 36;
      $OPTIONS["00176:Move disc 0 from bin B to bin A\n"] = 29;
      $OPTIONS["00177:Move disc 0 from bin B to bin C\n"] = 31;
      break;
    case 31: // state29:
      $my_desc .= "00178:Bin A: 2 1\n00179:Bin B: 3\n00180:Bin C: 0\n";
      $OPTIONS["00181:Move disc 1 from bin A to bin B\n"] = 34;
      $OPTIONS["00182:Move disc 0 from bin C to bin A\n"] = 29;
      $OPTIONS["00183:Move disc 0 from bin C to bin B\n"] = 30;
      break;
    case 32: // state30:
      $my_desc .= "00184:Bin A: 2 0\n00185:Bin B: 3 1\n00186:Bin C:\n";
      $OPTIONS["00187:Move disc 0 from bin A to bin B\n"] = 33;
      $OPTIONS["00188:Move disc 0 from bin A to bin C\n"] = 34;
      $OPTIONS["00189:Move disc 1 from bin B to bin C\n"] = 35;
      break;
    case 33: // state31:
      $my_desc .= "00190:Bin A: 2\n00191:Bin B: 3 1 0\n00192:Bin C:\n";
      $OPTIONS["00193:Move disc 2 from bin A to bin C\n"] = 51;
      $OPTIONS["00194:Move disc 0 from bin B to bin A\n"] = 32;
      $OPTIONS["00195:Move disc 0 from bin B to bin C\n"] = 34;
      break;
    case 34: // state32:
      $my_desc .= "00196:Bin A: 2\n00197:Bin B: 3 1\n00198:Bin C: 0\n";
      $OPTIONS["00199:Move disc 1 from bin B to bin A\n"] = 31;
      $OPTIONS["00200:Move disc 0 from bin C to bin A\n"] = 32;
      $OPTIONS["00201:Move disc 0 from bin C to bin B\n"] = 33;
      break;
    case 35: // state33:
      $my_desc .= "00202:Bin A: 2 0\n00203:Bin B: 3\n00204:Bin C: 1\n";
      $OPTIONS["00205:Move disc 0 from bin A to bin B\n"] = 36;
      $OPTIONS["00206:Move disc 0 from bin A to bin C\n"] = 37;
      $OPTIONS["00207:Move disc 1 from bin C to bin B\n"] = 32;
      break;
    case 36: // state34:
      $my_desc .= "00208:Bin A: 2\n00209:Bin B: 3 0\n00210:Bin C: 1\n";
      $OPTIONS["00211:Move disc 0 from bin B to bin A\n"] = 35;
      $OPTIONS["00212:Move disc 0 from bin B to bin C\n"] = 37;
      $OPTIONS["00213:Move disc 1 from bin C to bin A\n"] = 30;
      break;
    case 37: // state35:
      $my_desc .= "00214:Bin A: 2\n00215:Bin B: 3\n00216:Bin C: 1 0\n";
      $OPTIONS["00217:Move disc 2 from bin A to bin B\n"] = 46;
      $OPTIONS["00218:Move disc 0 from bin C to bin A\n"] = 35;
      $OPTIONS["00219:Move disc 0 from bin C to bin B\n"] = 36;
      break;
    case 38: // state36:
      $my_desc .= "00220:Bin A: 1 0\n00221:Bin B: 3 2\n00222:Bin C:\n";
      $OPTIONS["00223:Move disc 0 from bin A to bin B\n"] = 39;
      $OPTIONS["00224:Move disc 0 from bin A to bin C\n"] = 40;
      $OPTIONS["00225:Move disc 2 from bin B to bin C\n"] = 47;
      break;
    case 39: // state37:
      $my_desc .= "00226:Bin A: 1\n00227:Bin B: 3 2 0\n00228:Bin C:\n";
      $OPTIONS["00229:Move disc 1 from bin A to bin C\n"] = 45;
      $OPTIONS["00230:Move disc 0 from bin B to bin A\n"] = 38;
      $OPTIONS["00231:Move disc 0 from bin B to bin C\n"] = 40;
      break;
    case 40: // state38:
      $my_desc .= "00232:Bin A: 1\n00233:Bin B: 3 2\n00234:Bin C: 0\n";
      $OPTIONS["00235:Move disc 1 from bin A to bin B\n"] = 43;
      $OPTIONS["00236:Move disc 0 from bin C to bin A\n"] = 38;
      $OPTIONS["00237:Move disc 0 from bin C to bin B\n"] = 39;
      break;
    case 41: // state39:
      $my_desc .= "00238:Bin A: 0\n00239:Bin B: 3 2 1\n00240:Bin C:\n";
      $OPTIONS["00241:Move disc 0 from bin A to bin B\n"] = 42;
      $OPTIONS["00242:Move disc 0 from bin A to bin C\n"] = 43;
      $OPTIONS["00243:Move disc 1 from bin B to bin C\n"] = 44;
      break;
    case 42: // state40:
      $my_desc .= "00244:Bin A:\n00245:Bin B: 3 2 1 0\n00246:Bin C:\n00247:GAME COMPLETE (ENDING 2 OF 2)\n";
      $assigns['ENDING_TWO'] = 1;
      $next = 1; /* CHECK_ENDING */
      break;
    case 43: // state41:
      $my_desc .= "00248:Bin A:\n00249:Bin B: 3 2 1\n00250:Bin C: 0\n";
      $OPTIONS["00251:Move disc 1 from bin B to bin A\n"] = 40;
      $OPTIONS["00252:Move disc 0 from bin C to bin A\n"] = 41;
      $OPTIONS["00253:Move disc 0 from bin C to bin B\n"] = 42;
      break;
    case 44: // state42:
      $my_desc .= "00254:Bin A: 0\n00255:Bin B: 3 2\n00256:Bin C: 1\n";
      $OPTIONS["00257:Move disc 0 from bin A to bin B\n"] = 45;
      $OPTIONS["00258:Move disc 0 from bin A to bin C\n"] = 46;
      $OPTIONS["00259:Move disc 1 from bin C to bin B\n"] = 41;
      break;
    case 45: // state43:
      $my_desc .= "00260:Bin A:\n00261:Bin B: 3 2 0\n00262:Bin C: 1\n";
      $OPTIONS["00263:Move disc 0 from bin B to bin A\n"] = 44;
      $OPTIONS["00264:Move disc 0 from bin B to bin C\n"] = 46;
      $OPTIONS["00265:Move disc 1 from bin C to bin A\n"] = 39;
      break;
    case 46: // state44:
      $my_desc .= "00266:Bin A:\n00267:Bin B: 3 2\n00268:Bin C: 1 0\n";
      $OPTIONS["00269:Move disc 2 from bin B to bin A\n"] = 37;
      $OPTIONS["00270:Move disc 0 from bin C to bin A\n"] = 44;
      $OPTIONS["00271:Move disc 0 from bin C to bin B\n"] = 45;
      break;
    case 47: // state45:
      $my_desc .= "00272:Bin A: 1 0\n00273:Bin B: 3\n00274:Bin C: 2\n";
      $OPTIONS["00275:Move disc 0 from bin A to bin B\n"] = 48;
      $OPTIONS["00276:Move disc 0 from bin A to bin C\n"] = 49;
      $OPTIONS["00277:Move disc 2 from bin C to bin B\n"] = 38;
      break;
    case 48: // state46:
      $my_desc .= "00278:Bin A: 1\n00279:Bin B: 3 0\n00280:Bin C: 2\n";
      $OPTIONS["00281:Move disc 1 from bin A to bin C\n"] = 54;
      $OPTIONS["00282:Move disc 0 from bin B to bin A\n"] = 47;
      $OPTIONS["00283:Move disc 0 from bin B to bin C\n"] = 49;
      break;
    case 49: // state47:
      $my_desc .= "00284:Bin A: 1\n00285:Bin B: 3\n00286:Bin C: 2 0\n";
      $OPTIONS["00287:Move disc 1 from bin A to bin B\n"] = 52;
      $OPTIONS["00288:Move disc 0 from bin C to bin A\n"] = 47;
      $OPTIONS["00289:Move disc 0 from bin C to bin B\n"] = 48;
      break;
    case 50: // state48:
      $my_desc .= "00290:Bin A: 0\n00291:Bin B: 3 1\n00292:Bin C: 2\n";
      $OPTIONS["00293:Move disc 0 from bin A to bin B\n"] = 51;
      $OPTIONS["00294:Move disc 0 from bin A to bin C\n"] = 52;
      $OPTIONS["00295:Move disc 1 from bin B to bin C\n"] = 53;
      break;
    case 51: // state49:
      $my_desc .= "00296:Bin A:\n00297:Bin B: 3 1 0\n00298:Bin C: 2\n";
      $OPTIONS["00299:Move disc 0 from bin B to bin A\n"] = 50;
      $OPTIONS["00300:Move disc 0 from bin B to bin C\n"] = 52;
      $OPTIONS["00301:Move disc 2 from bin C to bin A\n"] = 33;
      break;
    case 52: // state50:
      $my_desc .= "00302:Bin A:\n00303:Bin B: 3 1\n00304:Bin C: 2 0\n";
      $OPTIONS["00305:Move disc 1 from bin B to bin A\n"] = 49;
      $OPTIONS["00306:Move disc 0 from bin C to bin A\n"] = 50;
      $OPTIONS["00307:Move disc 0 from bin C to bin B\n"] = 51;
      break;
    case 53: // state51:
      $my_desc .= "00308:Bin A: 0\n00309:Bin B: 3\n00310:Bin C: 2 1\n";
      $OPTIONS["00311:Move disc 0 from bin A to bin B\n"] = 54;
      $OPTIONS["00312:Move disc 0 from bin A to bin C\n"] = 55;
      $OPTIONS["00313:Move disc 1 from bin C to bin B\n"] = 50;
      break;
    case 54: // state52:
      $my_desc .= "00314:Bin A:\n00315:Bin B: 3 0\n00316:Bin C: 2 1\n";
      $OPTIONS["00317:Move disc 0 from bin B to bin A\n"] = 53;
      $OPTIONS["00318:Move disc 0 from bin B to bin C\n"] = 55;
      $OPTIONS["00319:Move disc 1 from bin C to bin A\n"] = 48;
      break;
    case 55: // state53:
      $my_desc .= "00320:Bin A:\n00321:Bin B: 3\n00322:Bin C: 2 1 0\n";
      $OPTIONS["00323:Move disc 3 from bin B to bin A\n"] = 28;
      $OPTIONS["00324:Move disc 0 from bin C to bin A\n"] = 53;
      $OPTIONS["00325:Move disc 0 from bin C to bin B\n"] = 54;
      break;
    case 56: // state54:
      $my_desc .= "00326:Bin A: 2 1 0\n00327:Bin B:\n00328:Bin C: 3\n";
      $OPTIONS["00329:Move disc 0 from bin A to bin B\n"] = 57;
      $OPTIONS["00330:Move disc 0 from bin A to bin C\n"] = 58;
      $OPTIONS["00331:Move disc 3 from bin C to bin B\n"] = 29;
      break;
    case 57: // state55:
      $my_desc .= "00332:Bin A: 2 1\n00333:Bin B: 0\n00334:Bin C: 3\n";
      $OPTIONS["00335:Move disc 1 from bin A to bin C\n"] = 63;
      $OPTIONS["00336:Move disc 0 from bin B to bin A\n"] = 56;
      $OPTIONS["00337:Move disc 0 from bin B to bin C\n"] = 58;
      break;
    case 58: // state56:
      $my_desc .= "00338:Bin A: 2 1\n00339:Bin B:\n00340:Bin C: 3 0\n";
      $OPTIONS["00341:Move disc 1 from bin A to bin B\n"] = 61;
      $OPTIONS["00342:Move disc 0 from bin C to bin A\n"] = 56;
      $OPTIONS["00343:Move disc 0 from bin C to bin B\n"] = 57;
      break;
    case 59: // state57:
      $my_desc .= "00344:Bin A: 2 0\n00345:Bin B: 1\n00346:Bin C: 3\n";
      $OPTIONS["00347:Move disc 0 from bin A to bin B\n"] = 60;
      $OPTIONS["00348:Move disc 0 from bin A to bin C\n"] = 61;
      $OPTIONS["00349:Move disc 1 from bin B to bin C\n"] = 62;
      break;
    case 60: // state58:
      $my_desc .= "00350:Bin A: 2\n00351:Bin B: 1 0\n00352:Bin C: 3\n";
      $OPTIONS["00353:Move disc 2 from bin A to bin C\n"] = 78;
      $OPTIONS["00354:Move disc 0 from bin B to bin A\n"] = 59;
      $OPTIONS["00355:Move disc 0 from bin B to bin C\n"] = 61;
      break;
    case 61: // state59:
      $my_desc .= "00356:Bin A: 2\n00357:Bin B: 1\n00358:Bin C: 3 0\n";
      $OPTIONS["00359:Move disc 1 from bin B to bin A\n"] = 58;
      $OPTIONS["00360:Move disc 0 from bin C to bin A\n"] = 59;
      $OPTIONS["00361:Move disc 0 from bin C to bin B\n"] = 60;
      break;
    case 62: // state60:
      $my_desc .= "00362:Bin A: 2 0\n00363:Bin B:\n00364:Bin C: 3 1\n";
      $OPTIONS["00365:Move disc 0 from bin A to bin B\n"] = 63;
      $OPTIONS["00366:Move disc 0 from bin A to bin C\n"] = 64;
      $OPTIONS["00367:Move disc 1 from bin C to bin B\n"] = 59;
      break;
    case 63: // state61:
      $my_desc .= "00368:Bin A: 2\n00369:Bin B: 0\n00370:Bin C: 3 1\n";
      $OPTIONS["00371:Move disc 0 from bin B to bin A\n"] = 62;
      $OPTIONS["00372:Move disc 0 from bin B to bin C\n"] = 64;
      $OPTIONS["00373:Move disc 1 from bin C to bin A\n"] = 57;
      break;
    case 64: // state62:
      $my_desc .= "00374:Bin A: 2\n00375:Bin B:\n00376:Bin C: 3 1 0\n";
      $OPTIONS["00377:Move disc 2 from bin A to bin B\n"] = 73;
      $OPTIONS["00378:Move disc 0 from bin C to bin A\n"] = 62;
      $OPTIONS["00379:Move disc 0 from bin C to bin B\n"] = 63;
      break;
    case 65: // state63:
      $my_desc .= "00380:Bin A: 1 0\n00381:Bin B: 2\n00382:Bin C: 3\n";
      $OPTIONS["00383:Move disc 0 from bin A to bin B\n"] = 66;
      $OPTIONS["00384:Move disc 0 from bin A to bin C\n"] = 67;
      $OPTIONS["00385:Move disc 2 from bin B to bin C\n"] = 74;
      break;
    case 66: // state64:
      $my_desc .= "00386:Bin A: 1\n00387:Bin B: 2 0\n00388:Bin C: 3\n";
      $OPTIONS["00389:Move disc 1 from bin A to bin C\n"] = 72;
      $OPTIONS["00390:Move disc 0 from bin B to bin A\n"] = 65;
      $OPTIONS["00391:Move disc 0 from bin B to bin C\n"] = 67;
      break;
    case 67: // state65:
      $my_desc .= "00392:Bin A: 1\n00393:Bin B: 2\n00394:Bin C: 3 0\n";
      $OPTIONS["00395:Move disc 1 from bin A to bin B\n"] = 70;
      $OPTIONS["00396:Move disc 0 from bin C to bin A\n"] = 65;
      $OPTIONS["00397:Move disc 0 from bin C to bin B\n"] = 66;
      break;
    case 68: // state66:
      $my_desc .= "00398:Bin A: 0\n00399:Bin B: 2 1\n00400:Bin C: 3\n";
      $OPTIONS["00401:Move disc 0 from bin A to bin B\n"] = 69;
      $OPTIONS["00402:Move disc 0 from bin A to bin C\n"] = 70;
      $OPTIONS["00403:Move disc 1 from bin B to bin C\n"] = 71;
      break;
    case 69: // state67:
      $my_desc .= "00404:Bin A:\n00405:Bin B: 2 1 0\n00406:Bin C: 3\n";
      $OPTIONS["00407:Move disc 0 from bin B to bin A\n"] = 68;
      $OPTIONS["00408:Move disc 0 from bin B to bin C\n"] = 70;
      $OPTIONS["00409:Move disc 3 from bin C to bin A\n"] = 15;
      break;
    case 70: // state68:
      $my_desc .= "00410:Bin A:\n00411:Bin B: 2 1\n00412:Bin C: 3 0\n";
      $OPTIONS["00413:Move disc 1 from bin B to bin A\n"] = 67;
      $OPTIONS["00414:Move disc 0 from bin C to bin A\n"] = 68;
      $OPTIONS["00415:Move disc 0 from bin C to bin B\n"] = 69;
      break;
    case 71: // state69:
      $my_desc .= "00416:Bin A: 0\n00417:Bin B: 2\n00418:Bin C: 3 1\n";
      $OPTIONS["00419:Move disc 0 from bin A to bin B\n"] = 72;
      $OPTIONS["00420:Move disc 0 from bin A to bin C\n"] = 73;
      $OPTIONS["00421:Move disc 1 from bin C to bin B\n"] = 68;
      break;
    case 72: // state70:
      $my_desc .= "00422:Bin A:\n00423:Bin B: 2 0\n00424:Bin C: 3 1\n";
      $OPTIONS["00425:Move disc 0 from bin B to bin A\n"] = 71;
      $OPTIONS["00426:Move disc 0 from bin B to bin C\n"] = 73;
      $OPTIONS["00427:Move disc 1 from bin C to bin A\n"] = 66;
      break;
    case 73: // state71:
      $my_desc .= "00428:Bin A:\n00429:Bin B: 2\n00430:Bin C: 3 1 0\n";
      $OPTIONS["00431:Move disc 2 from bin B to bin A\n"] = 64;
      $OPTIONS["00432:Move disc 0 from bin C to bin A\n"] = 71;
      $OPTIONS["00433:Move disc 0 from bin C to bin B\n"] = 72;
      break;
    case 74: // state72:
      $my_desc .= "00434:Bin A: 1 0\n00435:Bin B:\n00436:Bin C: 3 2\n";
      $OPTIONS["00437:Move disc 0 from bin A to bin B\n"] = 75;
      $OPTIONS["00438:Move disc 0 from bin A to bin C\n"] = 76;
      $OPTIONS["00439:Move disc 2 from bin C to bin B\n"] = 65;
      break;
    case 75: // state73:
      $my_desc .= "00440:Bin A: 1\n00441:Bin B: 0\n00442:Bin C: 3 2\n";
      $OPTIONS["00443:Move disc 1 from bin A to bin C\n"] = 81;
      $OPTIONS["00444:Move disc 0 from bin B to bin A\n"] = 74;
      $OPTIONS["00445:Move disc 0 from bin B to bin C\n"] = 76;
      break;
    case 76: // state74:
      $my_desc .= "00446:Bin A: 1\n00447:Bin B:\n00448:Bin C: 3 2 0\n";
      $OPTIONS["00449:Move disc 1 from bin A to bin B\n"] = 79;
      $OPTIONS["00450:Move disc 0 from bin C to bin A\n"] = 74;
      $OPTIONS["00451:Move disc 0 from bin C to bin B\n"] = 75;
      break;
    case 77: // state75:
      $my_desc .= "00452:Bin A: 0\n00453:Bin B: 1\n00454:Bin C: 3 2\n";
      $OPTIONS["00455:Move disc 0 from bin A to bin B\n"] = 78;
      $OPTIONS["00456:Move disc 0 from bin A to bin C\n"] = 79;
      $OPTIONS["00457:Move disc 1 from bin B to bin C\n"] = 80;
      break;
    case 78: // state76:
      $my_desc .= "00458:Bin A:\n00459:Bin B: 1 0\n00460:Bin C: 3 2\n";
      $OPTIONS["00461:Move disc 0 from bin B to bin A\n"] = 77;
      $OPTIONS["00462:Move disc 0 from bin B to bin C\n"] = 79;
      $OPTIONS["00463:Move disc 2 from bin C to bin A\n"] = 60;
      break;
    case 79: // state77:
      $my_desc .= "00464:Bin A:\n00465:Bin B: 1\n00466:Bin C: 3 2 0\n";
      $OPTIONS["00467:Move disc 1 from bin B to bin A\n"] = 76;
      $OPTIONS["00468:Move disc 0 from bin C to bin A\n"] = 77;
      $OPTIONS["00469:Move disc 0 from bin C to bin B\n"] = 78;
      break;
    case 80: // state78:
      $my_desc .= "00470:Bin A: 0\n00471:Bin B:\n00472:Bin C: 3 2 1\n";
      $OPTIONS["00473:Move disc 0 from bin A to bin B\n"] = 81;
      $OPTIONS["00474:Move disc 0 from bin A to bin C\n"] = 82;
      $OPTIONS["00475:Move disc 1 from bin C to bin B\n"] = 77;
      break;
    case 81: // state79:
      $my_desc .= "00476:Bin A:\n00477:Bin B: 0\n00478:Bin C: 3 2 1\n";
      $OPTIONS["00479:Move disc 0 from bin B to bin A\n"] = 80;
      $OPTIONS["00480:Move disc 0 from bin B to bin C\n"] = 82;
      $OPTIONS["00481:Move disc 1 from bin C to bin A\n"] = 75;
      break;
    case 82: // state80:
      $my_desc .= "00482:Bin A:\n00483:Bin B:\n00484:Bin C: 3 2 1 0\n00485:GAME COMPLETE (ENDING 1 OF 2)\n";
      $assigns['ENDING_ONE'] = 1;
      $next = 1; /* CHECK_ENDING */
      break;
  }
  AppendDesc($my_desc);
  foreach($assigns as $k => $v)
    $GLOBALS[$k] = $v;
  if($GLOBALS['GAMEOVER'])
  {
    global $DESC;
    $DESC .= "99998:\n99999:GAME OVER\n";
  }
  } while($next >= 0);
}
$req = EncodeRequest();
Collect($CUR_ROOM);
?><html><head>
 <title>Game title here</title>
 <link rel="stylesheet" href="game.css"></head><body>
<?php echo '<h2>', 'Page ', preg_replace('/,.*/', '', $req), '</h2>', "\n";
 $desc_lines = explode("\n", preg_replace("/\n$/", '', $DESC));
 $nl = '';
 foreach($desc_lines as $line)
 {
   if($line == '') continue;
   $line = preg_replace('/^[0-9]*:/', '', $line);
   if($line != '' && $line[0] == '\\')
     $line = substr($line, 1);
   else
     echo $nl;
   echo htmlspecialchars($line);
   $nl = '&nbsp;<br>';
 }
?> <p><ul>
<?php ksort($OPTIONS);
 foreach($OPTIONS as $label => $target)
 {
   $CUR_ROOM = $target;
   $link = '?req='.(EncodeRequest());
   echo '<li>';
   $label_html = htmlspecialchars(preg_replace('/^[0-9]*:/', '', $label));
   echo '<a href="',htmlspecialchars($link),'">',$label_html,'</a>';
   echo '</li>';
 }
 if(empty($OPTIONS))
 {
   echo '<li><a href="?">Start a new game</a></li>';
 }
?> </ul>
 <hr><small>This is part of The Author's The Game interactive book</small></body></html>
